/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni ... textove retezce a datovy typ string
*/
#include<iostream>
#include<cstring> // strlen, strcpy, strcmp 
#include<string> // string
using namespace std;

/* Funkce vrati delku textoveho retezce s. */
int delkaRetezce(string s)
{
	int n = 0;
	while (s[n] != '\0')
		n++;
	return n;
}

/* Funkce vrati delku textoveho retezce s. */
int delkaRetezce(const char s[])
{
	int n = 0;
	while (s[n] != '\0')
		n++;
	return n;
}

/* Funkce zkopiruje obsah retezce s do retezce t. */
void kopiruj(char t[], const char s[])
{
	int n = delkaRetezce(s);
	for (int i = 0; i <= n; i++) // vcetne koncove nuly
	{
		t[i] = s[i];
	}
}

/* Funkce NEvypise delku retezce a. */
void vypis(int a[])
{
	cout << "ve\tfunkci\n";
	cout << "  Velikost pole v bytech NENI " << sizeof(a) << endl;
	cout << "  Pocet prvku pole NENI " << sizeof(a) / sizeof(int) << endl;
}

/* Pokud je c male pismeno, funkce vrati odpovidajici velke pismeno.
   Jinak funkce vrati znak c beze zmeny.
 */
char naVelke(char c)
{
	if (c >= 'a' && c <= 'z')
		c = c - 'a' + 'A';
	return c;
}

/* Funkce prevede vsechna
   mala pismena v s na velka a vysledek vrati */
string naVelka(string s)
{
	// todo
	return s;
}

/* Funkce nacte radek textu, pak v nem prevede vsechna
   mala pismena na velka a vysledny radek vypise na konzoli */
void celyRadek1()
{
	cout << "zadej radek textu: ";
	string s;
	getline(cin, s);
	cout << naVelka(s) << endl;
}

/* Funkce nacte radek textu, pak v nem prevede vsechna
   mala pismena na velka a vysledny radek vypise na konzoli */
void celyRadek()
{
	char c;
	cout << "zadej radek textu: ";
	do
	{
		//cin >> c; // !! nefungovalo by spravne!!
		c = getchar();
		cout << naVelke(c);

	} while (c != '\n');
	cout << endl;

}

/* Funkce zasifruje zpravu pomoci substitucni sifry. Vrati vysledek. */
string zasifrujSubstituci(string zprava, int posun)
{
	//todo
	return zprava;
}

int main()
{
	/* Priklady s textovym retezcem reprezentovanym jako pole charu. */
	{
		char a[256], b[256], c[256];
		char s[10] = "text";
		char s1[10] = { 't','e','x','t','\0' };

		// zmena znaku:
		s[2] = 's';
		s[4] = 'y';
		cout << s << endl;
		cout << s1 << endl;

		// delka retezce (vlastni a knihovni funkce):
		cout << delkaRetezce(s) << endl;
		cout << delkaRetezce(s1) << endl;
		cout << strlen(s) << endl;
		cout << strlen(s1) << endl;

		// kopirovani retezcu (vlastni a knihovni funkce): 
		kopiruj(a, s);
		strcpy_s(b, s);
		strcpy_s(c, sizeof(s), s);
		cout << a << endl;
		// nejde!!!:
		//a = s;
		//a = "pes";

        // porovnani retezcu:
		if (strcmp(s, s1) == 0)
			cout << "jsou stejne\n";
		//if (a == b) !!! nelze !!!
		//	;

		// nacitani retezce z konzole:
		cout << "zadej nejaky text:";
		cin >> a; // nacte text po prvni bily znak (' ','\t','\n')
		cin.getline(b, 255); // nacte text do konce radku (znak '\n')
		cin.getline(c, 255, '.');  //nacte text az po znak '.'

		// vypis retezce na konzoli:
		cout << a << endl;
		cout << b << endl;
		cout << c << endl;

	}

	// sizeof:
	{
		int x = 2;
		int a[10];
		cout << sizeof(int) << endl;
		cout << sizeof(x) << endl;
		cout << sizeof(char) << endl;
		cout << sizeof(a) << endl;
		cout << sizeof(a) / sizeof(int) << endl;
		vypis(a);
		cout << endl;
	}

	/* Priklady na datovy typ string. */
	{
		string a, b, c;
		string s = "text";
		string s1 = { 't','e','x','t','\0' };

		// zmena znaku:
		s[2] = 's';
		// nemuzu s[4] = 'y';
		s = s + 'y';
		s[4] = 'a';

		// vypis na konzoli:
		cout << s << endl;
		cout << s1 << endl;

		// delka retezce (vlastni a knihovni funkce):
		cout << delkaRetezce(s) << endl;
		cout << delkaRetezce(s1) << endl;
		cout << s.length() << endl;
		cout << s1.length() << endl;

		// kopirovani retezcu:
		a = s;     //pro string toto jde
		a = "pes";
		b = "pas";

		// konkatenace:
		c = s + " " + a + s1 + ' ';

		cout << a << endl;
		cout << b << endl;
		cout << c << endl;
		
		// porovnani retezcu:
		if (a == b)
			cout << "jsou stejne\n";
		else if (a < b)
			cout << "a lexikograficky mensi";

		// nacitani retezce z konzole:
		cout << "zadej nejaky text:";
		cin >> a; // nacte text po prvni bily znak (' ','\t','\n')
		getline(cin, b); // nacte text do konce radku (znak '\n')
		getline(cin, c, '.'); //nacte text az po znak '.'

		cout << a << endl;
		cout << b << endl;
		cout << c << endl;
        
		// konverze mezi string a char[]
		char x[10] = "ahoj";
		a = x;
		strcpy_s(x, s.data());
		cout << a << endl;
		cout << x << endl;

	}

	// Priklady na procviceni (kostra):
	celyRadek1();
	celyRadek();
	
	{
		string testovaci = "abcdefghijklmnopqrtsuvwxyz 1234567890!@#$%&*) \t ABCDEFGHIJKLMNOPQRSTUVWXYZ";
		string a = zasifrujSubstituci(testovaci, 10);
		cout << a << endl;
		string b = zasifrujSubstituci(a, -10);
		cout << b << endl;

		a = zasifrujSubstituci(testovaci, 150);
		cout << a << endl;
		b = zasifrujSubstituci(a, -150);
		cout << b << endl;
	}
	


	return 0;
}